﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.SharePoint.Client;
using AppOnlyContactWeb.Models;

namespace AppOnlyContactWeb.Controllers
{
    public class DefaultController : Controller
    {
        public ActionResult Index()
        {
            Uri hostWebUri = new Uri(Request.QueryString["SPHostUrl"]);
            ViewModel viewModel = new ViewModel();

            string appOnlyAccessToken = TokenHelper.GetS2SAccessTokenWithWindowsIdentity(hostWebUri,null);
            using (ClientContext ctx = TokenHelper.GetClientContextWithAccessToken(hostWebUri.ToString(), appOnlyAccessToken))
            {
                List list = ctx.Web.Lists.GetByTitle("Contacts");
                ctx.Load(list);
                CamlQuery query = CamlQuery.CreateAllItemsQuery();
                ListItemCollection items = list.GetItems(query);
                ctx.Load(items);
                ctx.ExecuteQuery();

                foreach (ListItem item in items)
                {
                    viewModel.Contacts.Add(new Contact()
                    {
                        Id = item["ID"].ToString(),
                        LastName = item["Title"].ToString(),
                        FirstName = item["FirstName"].ToString(),
                        Email = item["Email"].ToString()
                    });
                }

            }

            ViewBag.SPHostUrl = Request.QueryString["SPHostUrl"];
            return View(viewModel);
        }

        public ActionResult EditContact(String SPHostUrl, String Id)
        {
            Contact contact = new Contact();
            Uri hostWebUri = new Uri(SPHostUrl);
            string appOnlyAccessToken = TokenHelper.GetS2SAccessTokenWithWindowsIdentity(hostWebUri, null);
            using (ClientContext ctx = TokenHelper.GetClientContextWithAccessToken(hostWebUri.ToString(), appOnlyAccessToken))
            {
                List list = ctx.Web.Lists.GetByTitle("Contacts");
                ctx.Load(list);

                ListItem item = list.GetItemById(Id);
                ctx.Load(item);

                ctx.ExecuteQuery();

                contact.Id = item["ID"].ToString();
                contact.LastName = item["Title"].ToString();
                contact.FirstName = item["FirstName"].ToString();
                contact.Email = item["Email"].ToString();

            }

            ViewBag.SPHostUrl = SPHostUrl;
            ViewBag.Contact = contact;
            return View();
        }

        public ActionResult UpdateContact(String SPHostUrl, String Id, String LastName, string FirstName, string Email)
        {
            Uri hostWebUri = new Uri(SPHostUrl);
            string appOnlyAccessToken = TokenHelper.GetS2SAccessTokenWithWindowsIdentity(hostWebUri, null);
            using (ClientContext ctx = TokenHelper.GetClientContextWithAccessToken(hostWebUri.ToString(), appOnlyAccessToken))
            {
                List list = ctx.Web.Lists.GetByTitle("Contacts");
                ctx.Load(list);

                ListItem item = list.GetItemById(Id);
                ctx.Load(item);

                ctx.ExecuteQuery();

                item["Title"] = LastName;
                item["FirstName"] = FirstName;
                item["Email"] = Email;
                item.Update();
                ctx.ExecuteQuery();


            }
            return RedirectToAction("Index", new { SPHostUrl = SPHostUrl });
        }

    }
}
