﻿"use strict";

window.WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.Jsom.Security = function () {

    var getCurrentUser = function () {
        var deferred = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.user = ctx.get_web().get_currentUser();
        ctx.load(this.user);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferred.resolve(this.user); }),
            Function.createDelegate(this,
                function (sender, args) { deferred.reject(sender, args); }));

        return deferred.promise();
    },

    getSiteGroups = function () {
        var deferred = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.groups = ctx.get_web().get_siteGroups();
        ctx.load(this.groups);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferred.resolve(this.groups); }),
            Function.createDelegate(this,
                function (sender, args) { deferred.reject(sender, args); }));

        return deferred.promise();
    },

    addSiteGroup = function (title, description, roleType) {
        var deferred = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var createInfo = new SP.GroupCreationInformation();
        createInfo.set_title(title);
        createInfo.set_description(description);
        this.newGroup = ctx.get_web().get_siteGroups().add(createInfo);
        ctx.load(this.newGroup);
        var roleDefBinding = SP.RoleDefinitionBindingCollection.newObject(ctx);
        var roleDef = ctx.get_web().get_roleDefinitions().getByType(roleType);
        roleDefBinding.add(roleDef);
        var roleAssignments = ctx.get_web().get_roleAssignments();
        roleAssignments.add(this.newGroup, roleDefBinding);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferred.resolve(this.newGroup); }),
            Function.createDelegate(this,
                function (sender, args) { deferred.reject(sender, args); }));

        return deferred.promise();
    },

    checkPermissions = function (mask) {
        var deferred = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var permSet = new SP.BasePermissions();
        permSet.set(mask);
        this.flag = ctx.get_web().doesUserHavePermissions(permSet);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferred.resolve(this.flag); }),
            Function.createDelegate(this,
                function (sender, args) { deferred.reject(sender, args); }));

        return deferred.promise();

    };

    return {
        get_currentUser: getCurrentUser,
        get_siteGroups: getSiteGroups,
        add_siteGroup: addSiteGroup,
        check_Permissions: checkPermissions
    };

}();