﻿using System;
using System.IdentityModel;
using System.ComponentModel;
using System.Web;

using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.IdentityModel;
using Microsoft.IdentityModel.Claims;
using Microsoft.SharePoint;
using Microsoft.SharePoint.IdentityModel;
using Microsoft.SharePoint.Security;
using Microsoft.SharePoint.WebControls;

namespace ShowClaims.ShowClaims
{
    [ToolboxItemAttribute(false)]
    public class ShowClaims : WebPart
    {
        HtmlTable table;

        private HtmlTableRow tableRow(string col1, string col2)
        {
            HtmlTableRow row = new HtmlTableRow();
            HtmlTableCell cell1 = new HtmlTableCell();
            HtmlTableCell cell2 = new HtmlTableCell();
            cell1.InnerText = col1;
            cell2.InnerText = col2;
            row.Cells.Add(cell1);
            row.Cells.Add(cell2);
            return row;
        }

        protected override void CreateChildControls()
        {
            table = new HtmlTable();
            table.Border = 1;
            table.CellPadding = 3;
            table.CellSpacing = 3;
            this.Controls.Add(table);
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            try
            {
                //The SharePoint User
                SPUser spUser = SPContext.Current.Web.CurrentUser;
                writer.Write("<p>The current SPUser is " + spUser.Name + "</p>");

                //The Claims Identity
                IClaimsIdentity claimsId = (IClaimsIdentity)Page.User.Identity;
                writer.Write("<p>The current User is " + claimsId.Name + "</p>");

                //The Claims Set
                table.Rows.Add(tableRow("Claim Type", "Claim Value"));

                foreach (Claim claim in claimsId.Claims)
                {
                    table.Rows.Add(tableRow(claim.ClaimType, claim.Value));
                }

                table.RenderControl(writer);

            }
            catch (Exception x)
            {
                writer.Write("<p>" + x.Message + "</p>");
            }
        }
    }
}
