﻿"use strict"
window.WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};
WingtipToys.Rest = WingtipToys.Rest || {};

$(document).ready(function () {

    $("#mainDiv").hide();
    $("#loadingDiv").show();

    /***************/
    /* App Loading */
    /***************/

    //Create 2 libraries
    $.when(

        //One from REST
        WingtipToys.Rest.Libs.create(
        "REST Documents",
        "The REST Document Library",
        SP.ListTemplateType.announcements),

        //The other from JSOM
        WingtipToys.Jsom.Libs.create(
        "JSOM Documents",
        "The JSOM Document Library",
        SP.ListTemplateType.announcements)

    ).done(

            function (x1, x2) {

                var titleRest = x1[0].d.Title;
                var titleJsom = x2.get_title();

                //Load the ViewModels
                WingtipToys.ViewModel.Rest.load(titleRest);
                WingtipToys.ViewModel.Jsom.load(titleJsom);

                //Apply Knockout Bindings
                ko.applyBindings(WingtipToys.ViewModel.Rest, document.getElementById("restTable"));
                ko.applyBindings(WingtipToys.ViewModel.Jsom, document.getElementById("jsomTable"));

                //Show UI
                $("#mainDiv").show();
                $("#loadingDiv").hide();

            });

    //Upload a Document
    $("#uploadDocumentButton").click(function () {

        if (document.getElementById("inputFile").files.length === 0) {
            alert("Select a file!");
            return;
        }

        var parts = document.getElementById("inputFile").value.split("\\");
        var filename = parts[parts.length - 1];
        var file = document.getElementById("inputFile").files[0];

        WingtipToys.Rest.Libs.upload("/apps/shapps/LibraryOperations/REST%20Documents", filename, file)
        .then(
            function (data) {
                WingtipToys.ViewModel.Rest.load("REST Documents");
            },
            function (err) {
                alert(JSON.stringify(err));
            }
        );

        WingtipToys.Jsom.Libs.upload("/apps/shapps/LibraryOperations/JSOM%20Documents", filename, file)
        .then(
            function (files) {
                WingtipToys.ViewModel.Jsom.load("JSOM Documents");
            },
            function (sender, args) {
                alert(args.get_message());
            }
        );

    });

    //Download a Document
    $("#downloadDocumentButton").click(function () {

        if ($("#inputText").attr("value").length === 0) {
            alert("Enter a file name!");
            return;
        }

        var filename = $("#inputText").attr("value");

        WingtipToys.Rest.Libs.download("/apps/shapps/LibraryOperations/REST%20Documents/" + encodeURIComponent(filename))
        .then(
            function (data) {
                alert(data);
            },
            function (err) {
                alert(JSON.stringify(err));
            }
        );

    });

    //Set Library Template
    $("#setTemplateButton").click(function () {

        if (document.getElementById("inputFile").files.length === 0) {
            alert("Select a file!");
            return;
        }

        var parts = document.getElementById("inputFile").value.split("\\");
        var filename = parts[parts.length-1];
        var file = document.getElementById("inputFile").files[0];

        WingtipToys.Rest.Libs.upload("/apps/shapps/LibraryOperations/REST%20Documents/Forms", filename, file)
        .then(
            function (data) {
                WingtipToys.Rest.Libs.set_libraryTemplate("REST Documents", "REST%20Documents/Forms/" + filename)
                .then(
                    function (data) {
                        alert("Successfully set document template on 'REST Documents'");
                    },
                    function (err) {
                        alert(JSON.stringify(err));
                    }
                );
            },
            function (err) {
                alert(err.code);
            }
        );

        WingtipToys.Jsom.Libs.upload("/apps/shapps/LibraryOperations/JSOM%20Documents/Forms", filename, file)
        .then(
            function (files) {
                WingtipToys.Jsom.Libs.set_libraryTemplate("JSOM Documents", "JSOM%20Documents/Forms/" + filename)
                .then(
                    function (library) {
                        alert("Successfully set document template on 'JSOM Documents'");
                    },
                    function (sender, args) {
                        alert(args.get_message());
                    }
                );
            },
            function (err) {
                alert(err.code);
            }
        );

    });


    //Add a Content Type
    $("#addContentTypeButton").click(function () {

        WingtipToys.Rest.Libs.create_contentType("InvoiceRest", "A new content type")
        .then(
            function (data) {
                $("#RestCtypeId").attr("value", data.d.Id.StringValue);
                alert("Created new content type '" + data.d.Name + "'");
            },
            function (err) {
                alert(JSON.stringify(err));
            }
        );

        WingtipToys.Jsom.Libs.create_contentType("InvoiceJsom", "A new content type")
        .then(
            function (ctype) {
                $("#JsomCtypeId").attr("value", ctype.get_id());
                alert("Created new content type '" + ctype.get_name() + "'");
            },
            function (sender, args) {
                alert(args.get_message());
            }
        );

    });

    //Set CType Template
    $("#setCTypeTemplateButton").click(function () {

        if (document.getElementById("inputFile").files.length === 0) {
            alert("Select a file!");
            return;
        }

        var parts = document.getElementById("inputFile").value.split("\\");
        var filename = parts[parts.length - 1];
        var file = document.getElementById("inputFile").files[0];

        WingtipToys.Rest.Libs.upload("/apps/shapps/LibraryOperations/_cts/InvoiceRest", filename, file)
        .then(
            function (data) {
                WingtipToys.Rest.Libs.set_ctypeTemplate($("#RestCtypeId").attr("value"), filename)
                .then(
                    function (data) {
                        alert("Successfully set ctype template on 'REST Documents'");
                    },
                    function (err) {
                        alert(JSON.stringify(err));
                    }
                );
            },
            function (err) {
                alert(err.code);
            }
        );

        WingtipToys.Jsom.Libs.upload("/apps/shapps/LibraryOperations/_cts/InvoiceJsom", filename, file)
        .then(
            function (files) {
                WingtipToys.Jsom.Libs.set_ctypeTemplate($("#JsomCtypeId").attr("value"), filename)
                .then(
                    function (library) {
                        alert("Successfully set ctype template on 'JSOM Documents'");
                    },
                    function (sender, args) {
                        alert(args.get_message());
                    }
                );
            },
            function (err) {
                alert(err.code);
            }
        );

    });


    //Set CType Template
    $("#bindCTypeButton").click(function () {

        WingtipToys.Rest.Libs.bind_contentType("REST Documents", $("#RestCtypeId").attr("value"))
        .then(
            function (data) {
                alert("Bound " + data.d.Name);
            },
            function (err) {
                alert(JSON.stringify(err));
            }
        );

        WingtipToys.Jsom.Libs.bind_contentType("JSOM Documents", $("#JsomCtypeId").attr("value"))
        .then(
            function (ctype) {
                alert("Bound " + ctype.get_name());
            },
            function (sender, args) {
                alert(args.get_message());
            }
        );

    });

    //Delete Both Libraries
    $("#deleteLibsButton").click(function () {
        $.when(
        WingtipToys.Rest.Libs.remove("REST Documents"),
        WingtipToys.Jsom.Libs.remove("JSOM Documents")).done(

            function (x1, x2) {
                alert("Libraries are now deleted! You can safely leave the page.");
                $("#mainDiv").hide();
            }

        );
    });

});

/*****************/
/* App Unloading */
/*****************/

window.onbeforeunload = function () {
    if ($("#mainDiv").is(":visible")) {
        ; return "Don't leave without deleting the libraries!";
    }
}
