﻿"use strict";

window.WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.Jsom.LibItems = function () {

    var deferreds = new Array(),

    read= function (listName, id) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.item = list.getItemById(id);
        ctx.load(this.item, 'Include(ID,FileLeafRef,FileRef,FileDirRef)');
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.item); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    },

    readAll = function (listName) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var query = "<View><Query><OrderBy></OrderBy></Query><ViewFields><FieldRef Name='ID'/><FieldRef Name='FileLeafRef'/><FieldRef Name='FileRef'/><FieldRef Name='FileDirRef'/></ViewFields></View>";
        var camlQuery = new SP.CamlQuery();
        camlQuery.set_viewXml(query);
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.items = list.getItems(camlQuery);
        ctx.load(this.items, 'Include(ID,FileLeafRef,FileRef,FileDirRef,FileSystemObjectType)');
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.items); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    },

    update = function (listName, id, itemTitle) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.listItem = list.getItemById(id);
        this.listItem.set_item("Title", itemTitle);
        this.listItem.update();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.listItem); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    },

    remove = function (listName, id) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.listItem = list.getItemById(id);
        this.listItem.deleteObject();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    };

    //public interface
    return {
        update: update,
        remove: remove,
        read: read,
        readAll: readAll
    };

}();
