﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.Rest = WingtipToys.Rest || {};

WingtipToys.Rest.ListItems = function () {

    var create = function (listName, itemType, itemTitle) {
        var deferred = $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl +
                 "/_api/web/lists/getByTitle('" + listName + "')/items",
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': {
                        'type': itemType
                    },
                    'Title': itemTitle
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val()
            }
        });

        return deferred.promise();
    },

        read = function (listName, id) {
            var deferred = $.ajax(
                    {
                        url: _spPageContextInfo.webServerRelativeUrl +
                            "/_api/web/lists/getByTitle('" + listName + "')/getItemByStringId('" +
                            id + "')",
                        type: "GET",
                        headers: {
                            "accept": "application/json;odata=verbose",
                        }
                    }
                );

            return deferred.promise();
        },

        readAll = function (listName) {
            var deferred = $.ajax(
                    {
                        url: _spPageContextInfo.webServerRelativeUrl +
                            "/_api/web/lists/getByTitle('" + listName + "')/items/?" +
                            "$orderby=Title",
                        type: "GET",
                        headers: {
                            "accept": "application/json;odata=verbose",
                        }
                    }
                );

            return deferred.promise();
        },

        update = function (listName, itemType, id, itemTitle) {
            var deferred = $.ajax(
                    {
                        url: _spPageContextInfo.webServerRelativeUrl +
                            "/_api/web/lists/getByTitle('" + listName + "')/getItemByStringId('" +
                            id + "')",
                        type: "POST",
                        contentType: "application/json;odata=verbose",
                        data: JSON.stringify(
                        {
                            '__metadata': {
                                'type': itemType
                            },
                            'Title': itemTitle
                        }),
                        headers: {
                            "accept": "application/json;odata=verbose",
                            "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                            "IF-MATCH": "*",
                            "X-Http-Method": "PATCH"
                        }
                    }
                );

            return deferred.promise();

        },

        remove = function (listName, id) {
            var deferred = $.ajax(
                    {
                        url: _spPageContextInfo.webServerRelativeUrl +
                            "/_api/web/lists/getByTitle('" + listName + "')/getItemByStringId('" +
                            id + "')",
                        type: "DELETE",
                        headers: {
                            "accept": "application/json;odata=verbose",
                            "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                            "IF-MATCH": "*"
                        }
                    }
                );

            return deferred.promise();
        }

    //public interface
    return {
        create: create,
        update: update,
        remove: remove,
        read: read,
        readAll: readAll
    }

}();
