﻿"use strict";

window.WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.Jsom.ListItems = function () {

    var deferreds = new Array(),

    create = function (listName, itemTitle) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        var listItemCreationInfo = new SP.ListItemCreationInformation();
        this.newItem = list.addItem(listItemCreationInfo);
        this.newItem.set_item("Title", itemTitle);
        this.newItem.update();
        ctx.load(this.newItem);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () {
                    deferreds[deferreds.length - 1].resolve(this.newItem);
                }),
            Function.createDelegate(this,
                function (sender, args) {
                    deferreds[deferreds.length - 1].reject(sender, args);
                }));

        return deferreds[deferreds.length - 1].promise();

    },

    read= function (listName, id) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.item = list.getItemById(id);
        ctx.load(this.item, 'Include(ID,Title)');
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.item); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    },

    readAll = function (listName) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var query = "<View><Query><OrderBy><FieldRef Name='Title'/></OrderBy></Query><ViewFields><FieldRef Name='ID'/><FieldRef Name='Title'/></ViewFields></View>";
        var camlQuery = new SP.CamlQuery();
        camlQuery.set_viewXml(query);
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.items = list.getItems(camlQuery);
        ctx.load(this.items, 'Include(ID,Title)');
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.items); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    },

    update = function (listName, id, itemTitle) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.listItem = list.getItemById(id);
        this.listItem.set_item("Title", itemTitle);
        this.listItem.update();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.listItem); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    },

    remove = function (listName, id) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(listName);
        ctx.load(list);
        this.listItem = list.getItemById(id);
        this.listItem.deleteObject();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();
    };

    //public interface
    return {
        create: create,
        update: update,
        remove: remove,
        read: read,
        readAll: readAll
    }

}();
