﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.ViewModel = WingtipToys.ViewModel || {};
WingtipToys.Rest = WingtipToys.Rest || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.ViewModel.ListItem = function (title) {

        //private members
    var t = title,
        set_title = function (v) { t = v; },
        get_title = function () { return t; };

    //public interface
    return {
        set_title: set_title,
        get_title: get_title
    };
}

WingtipToys.ViewModel.Rest = function () {

    //private members
    var items = ko.observableArray(),
        titleDisplayName = ko.observable(),
        getItems = function () { return items; },
        getTitleDisplayName = function () { return titleDisplayName; },

        load = function (listTitle) {
            WingtipToys.Rest.ListItems.readAll(listTitle).then(
                function (data) {
                    var results = data.d.results;

                    items.removeAll();

                    for (var i = 0; i < results.length; i++) {
                        items.push(new WingtipToys.ViewModel.ListItem(results[i].Title));
                    }
                },
                function (err) {
                    items.removeAll();
                    alert(JSON.stringify(err));
                }
             );

            //Load Title Field display name
            WingtipToys.Rest.Fields.get_field(listTitle, "Title").then(
                function (data) {
                    titleDisplayName(data.d.Title);
                },
                function (err) {
                    titleDisplayName("[Title]");
                    alert(JSON.stringify(err));
                }
            );

        };


    //public interface
    return {
        load: load,
        get_items: getItems,
        get_titleDisplayName: getTitleDisplayName
    };

}();

WingtipToys.ViewModel.Jsom = function () {

    //private members
    var items = ko.observableArray(),
        titleDisplayName = ko.observable(),
        getItems = function () { return items; },
        getTitleDisplayName = function () { return titleDisplayName; },

        load = function (listTitle) {

            //Load Items
            WingtipToys.Jsom.ListItems.readAll(listTitle).then(
                function (listItems) {
                    items.removeAll();
                    
                    var enumerator = listItems.getEnumerator();

                    while (enumerator.moveNext()) {
                        var listItem = enumerator.get_current();
                        items.push(new WingtipToys.ViewModel.ListItem(listItem.get_item("Title")));
                    }

                },
                function (sender, args) {
                    items.removeAll();
                    alert(args.get_message());
                }
             );

            //Load Title Field display name
            WingtipToys.Jsom.Fields.get_field(listTitle, "Title").then(
                function (field) {
                    titleDisplayName(field.get_title());
                },
                function (sender, args) {
                    titleDisplayName("[Title]");
                    alert(args.get_message());
                }
            );
        };


    //public interface
    return {
        load: load,
        get_items: getItems,
        get_titleDisplayName: getTitleDisplayName
    };

}();
